/**
 * JASMINe
 * Copyright (C) 2009 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: PurgeTimerService.java 5569 2009-10-22 07:48:15Z ardaaydin $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.monitoring.eos.purgetimer.service;

import java.io.Serializable;

import javax.naming.NamingException;

import org.ow2.jasmine.event.messages.JasmineEventTimer;
import org.ow2.jasmine.monitoring.eos.common.jndilocator.ServiceLocator;
import org.ow2.jasmine.monitoring.eos.purgetimer.service.exchange.ExecuteAction;
import org.ow2.jasmine.monitoring.eos.purgetimer.service.exchange.ResultAction;
import org.ow2.jasmine.monitoring.eventswitch.beans.JasmineEventTimerSLBRemote;

public class PurgeTimerService implements Serializable {


    private static final long serialVersionUID = -8056979296509798113L;

    private JasmineEventTimerSLBRemote jasmineTimerRemote = null;

    public PurgeTimerService() throws NamingException {
        this.jasmineTimerRemote = (JasmineEventTimerSLBRemote) ServiceLocator.getInstance().getRemoteObject("db-ejb/timer");
    }

    public ResultAction execute(final ExecuteAction action) throws Exception {

        try {

            JasmineEventTimer event = new JasmineEventTimer();

            event.setMaxEntryAge(action.getMaxEntryAge());
            event.setMaxEntryNumber(action.getMaxEntryNumber());
            event.setExecutionStartDate(action.getExecutionStartDate());
            event.setExecutionStartHours(action.getExecutionStartHours());
            event.setExecutionInterval(action.getExecutionInterval());
            event.setExecuteOnAllServers(action.isExecuteOnAllServers());
            event.setImmediateExecution(action.isImmediateExecution());
            event.setDomainName(action.getDomainName());
            event.setServerName(action.getServerName());

            int result = jasmineTimerRemote.configureTimer(event);

            ResultAction executedAction = new ResultAction();
            executedAction.setResult(result);

            return executedAction;

        } catch (Exception e) {
            e.printStackTrace();
            throw e;
        }

    }

}
